<?

class FeatureDatasource extends ItemListActionDataSource {

var $sortCol;
var $sortWay;
var $sorted;
var $search;
var $group_id;

function FeatureDatasource($group_id) {
$this->sortCol = "id";
$this->sortWay = "ASC";
$this->sorted = true;
$this->search = "";
$this->group_id = (int)$group_id;
}

function setSearch($search) {
$this->search = $search;
}

function getSearch() {
return $this->search;
}

function getPlainResultSet( $fromIdx, $toIdx, &$count, $search = "", $fetchAll = false ) {
global $USER_ID;

$sql = "SELECT feature.id, feature.abbrev, feature.name_i18n, feature.description_i18n, feature.defaultvalue, 
		         feature.value, feature.edate, feature.cdate, feature.version, feature.allowuser, feature_user.value AS uservalue
			    FROM feature LEFT JOIN feature_user ON feature.id = feature_user.feature_id AND feature_user.user_id = ".sqlf_tl_num($USER_ID)." 
				  AND feature.allowuser = 1 WHERE feature.featuregroup_id = ".sqlf_tl_num($this->group_id);
$rs = query($sql);//            

$list = array();
foreach ($rs["arr"] as $key=>$row) {
$row["name"] = i18n($row["name_i18n"]);
$row["default"] = $row["defaultvalue"]?i18n("Activated"):i18n("Deactivated");
if ($row["value"] === "0") $row["global"] = i18n("Deactivated");
if ($row["value"] === "1") $row["global"] = i18n("Activated");
if ($row["value"] === "" || $row["value"] == -1) $row["global"] = i18n("Use from config file");
if ($row["uservalue"] === "0") $row["user"] = i18n("Deactivated");
if ($row["uservalue"] === "1") $row["user"] = i18n("Activated");
if ($row["uservalue"] == "" && $row["allowuser"]) $row["user"] = i18n("Use global settings");
if (!$row["allowuser"]) $row["user"] = i18n("Not customizeable");
$list[] = $row;
}
if ($this->sorted) {

}
return $list;
}

function isSearchable() {
return false;
}

function getKey() {
return "FeatureEdit";
}

function setSort( $column, $way ) {
$this->sortCol = $column;
$this->sortWay = $way;
$this->sorted = true;
}

function getCurrentSort( &$column, &$way ) {
if (!$this->sorted) return false;
$column = $this->sortCol;
$way = $this->sortWay;
return true;
}

function getSortWays( $column ) {
global $ICO_SORT_ASC, $ICO_SORT_DESC;
return array(
array("way"=>"ASC", "icon"=>$ICO_SORT_ASC),
array("way"=>"DESC", "icon"=>$ICO_SORT_DESC)
);
}

function getColumns() {
return array("name", "default", "global", "user", "description");
}

function hasColumnHeaders() {
return true;
}

function getColumnHeader( $column ) {
switch ($column) {
case "name": $txt = i18n("Feature"); break;
case "default": $txt = i18n("Default Value"); break;
case "global": $txt = i18n("Global Value"); break;
case "user": $txt = i18n("User Value"); break;
case "description": $txt = i18n("Description"); break;
default: $txt = "";
}
return $txt;
}

}

class FeatureActivateAction extends ItemListAction {

var $mode;

function FeatureActivateAction($mode) {
$this->mode = $mode;
}

function getCommandName() {
return "activate_".$this->mode;
}

function getDescription() {
return "Activate ".$this->mode;
}

function getIconTag() {
return "";
}

function performAction( $listID ) {
global $USER_ID;
if (count($listID) == 0) return;
if ($this->mode == "global") {
$sql = "UPDATE feature SET value = 1 WHERE id IN (".implode(",",sqlf_tl_num_array($listID)).")";
query($sql);//            
 } else if ($this->mode == "user") {
$sql = "SELECT feature.id, feature.allowuser, feature_user.user_id, feature_user.value FROM feature LEFT JOIN feature_user 
			        ON feature.id = feature_user.feature_id AND feature_user.user_id = ".sqlf_tl_num($USER_ID)."
					WHERE feature.id IN (".implode(",", sqlf_tl_num_array($listID)).")";
$rs = query($sql);//            
 foreach ($rs["arr"] as $key=>$r) {
if ($r["allowuser"]) {
if (!$r["user_id"]) {
$sql = "INSERT INTO feature_user (feature_id, user_id, value) VALUES (".sqlf_tl_num($r["id"]).", ".sqlf_tl_num($USER_ID).", 1)";
query($sql);//            
 } else if (!$r["value"]) {
$sql = "UPDATE feature_user SET value = 1 WHERE feature_id = ".sqlf_tl_num($r["id"])." AND user_id = ".sqlf_tl_num($USER_ID);
query($sql);//            
 }
}
}
}
}
}

class FeatureDeactivateAction extends ItemListAction {

var $mode;

function FeatureDeactivateAction($mode) {
$this->mode = $mode;
}

function getCommandName() {
return "deactivate_".$this->mode;
}

function getDescription() {
return "Deactivate ".$this->mode;
}

function getIconTag() {
return "";
}

function performAction( $listID ) {
global $USER_ID;
if (count($listID) == 0) return;
if ($this->mode == "global") {
$sql = "UPDATE feature SET value = 0 WHERE id IN (".implode( sqlf_tl_num_array($listID), ",").")";
query($sql);//            
 } else if ($this->mode == "user") {
$sql = "UPDATE feature_user SET value = 0 WHERE feature_id IN (". implode(",", sqlf_tl_num_array($listID)).") AND user_id = ".sqlf_tl_num($USER_ID);
query($sql);//            
 }
}
}

class FeatureResetAction extends ItemListAction {

var $mode;

function FeatureResetAction($mode) {
$this->mode = $mode;
}

function getCommandName() {
return "reset_".$this->mode;
}

function getDescription() {
return "Reset ".$this->mode;
}

function getIconTag() {
return "";
}

function performAction( $listID ) {
global $USER_ID;
if (count($listID) == 0) return;
if ($this->mode == "global") {
$sql = "UPDATE feature SET value = -1 WHERE id IN (".implode( sqlf_tl_num_array($listID), ",").")";
query($sql);//            
 } else if ($this->mode == "user") {
$sql = "DELETE FROM feature_user WHERE feature_id IN (". implode(",", sqlf_tl_num_array($listID)).") AND user_id = ".sqlf_tl_num($USER_ID);
query($sql);//            
 }
}
}


?>
